"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = extend;

var _fastLoops = require("fast-loops");

var _cssInJsUtils = require("css-in-js-utils");

var _isobject = _interopRequireDefault(require("isobject"));

var _felaUtils = require("fela-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function removeUndefined(style) {
  (0, _fastLoops.objectEach)(style, function (value, property) {
    if ((0, _isobject["default"])(value)) {
      style[property] = removeUndefined(value);
    } else if (Array.isArray(value)) {
      style[property] = (0, _fastLoops.arrayFilter)(value, function (item) {
        return !(0, _felaUtils.isUndefinedValue)(item);
      });
    } else if ((0, _felaUtils.isUndefinedValue)(value)) {
      delete style[property];
    }
  });
  return style;
}

function extendStyle(style, extension) {
  // extend conditional style objects
  if (extension && extension.hasOwnProperty('condition')) {
    if (extension.condition) {
      // eslint-disable-next-line no-use-before-define
      (0, _cssInJsUtils.assignStyle)(style, extendPlugin(extension.style));
    }
  } else {
    // extend basic style objects
    (0, _cssInJsUtils.assignStyle)(style, removeUndefined(extendPlugin(extension)));
  }
}

function extendPlugin(style) {
  (0, _fastLoops.objectEach)(style, function (value, property) {
    if (property === 'extend') {
      var extensions = [].concat(value);
      (0, _fastLoops.arrayEach)(extensions, function (extension) {
        return extendStyle(style, extension);
      });
      delete style[property];
    } else if ((0, _isobject["default"])(value)) {
      // support nested extend as well
      style[property] = extendPlugin(value);
    }
  });
  return style;
}

function extend() {
  return extendPlugin;
}